/*
 *  ldrawparser.cpp
 *  legotown3d
 *
 *  Created by Nico Bernold on 08.01.05.
 *  Copyright 2005 __MyCompanyName__. All rights reserved.
 *
 */

#include "heightMapTerrain.h"

HeightMapTerrain::HeightMapTerrain()
{	
}

HeightMapTerrain::~HeightMapTerrain()
{
}

bool HeightMapTerrain::loadBitmap(char* fileName)
{
	return bitmap = SDL_LoadBMP(fileName);	
}

bool HeightMapTerrain::createDisplayLists(int width, int height, int levelOfDetail)
{
	if (bitmap == NULL) return false;
	
	cout << "bitmap-dimensions: " << bitmap->w << "x" << bitmap->h << endl;
	
	if (bitmap->w % width != 0) return false;
	if (bitmap->h % height != 0) return false;
	
	if (levelOfDetail < 1 || levelOfDetail > 10) return false;
	
	int howManyListsWide = bitmap->w / width;
	int howManyListsHigh = bitmap->h / height;
	
	// calculate how many displayLists we'll create
	displayListCount = howManyListsWide * howManyListsHigh; 

	cout << "lists-information: " << howManyListsWide << " * " << howManyListsHigh << " = " << displayListCount << " display lists." << endl;
	
	displayListStart = glGenLists(displayListCount);
	if (displayListStart == 0)
	{
		cout << "could not generate " << displayListCount << " display lists. exiting. " << endl;
		return false;
	}

	int i,j;
	
	for (i=0; i<howManyListsHigh; i++)
	{
		for (j=0; j<howManyListsWide; j++)
		{
			if (readIntoList(j*width,i*height,width,height,levelOfDetail,i*howManyListsHigh + j) == false)
			{
				cout << "error while generating display lists. exiting. " << endl;
				return false;
			}

		}
	}
	
	return true;
}

bool HeightMapTerrain::readIntoList(int left, int top, int width, int height, int levelOfDetail, GLuint displayListNr)
{
	// y is the height value in OpenGL convention
	GLuint x,y,z;
	GLfloat col;
	
	cout << "creating list Nr " << displayListNr << endl;
	cout << "left, top, width, height: " << left << ", " << top << ", " << width << ", " << height << endl; 
	
	glNewList(displayListNr,GL_COMPILE);
	{
		for (z=top; z<top+height; z++)
		{
			glBegin(GL_QUAD_STRIP);
			{
				for (x=left; x<left+width; x++)
				{
					y = heightValue(x,z+1);
					col = y / 256.0;
					glColor3f(1.0,0.0,0.0);
					glVertex3i(x,y,z+1);
					
					y = heightValue(x,z);
					col = y / 256.0;
					glColor3f(1.0,0.0,0.0);
					glVertex3i(x,y,z);
				}
			}
			glEnd();
		}
		
	}
	glEndList();
	
	return true;
}

GLint HeightMapTerrain::heightValue(Uint8 x, Uint8 z)
{
	return 100;
	
	/*
	if (bitmap == NULL) return 0;
	
	Uint8 index;
	SDL_Color* color = NULL;
	
	
	SDL_LockSurface(bitmap);
	
	index = *((Uint8*)bitmap->pixels[z * bitmap->h + x]);
	color = &bitmap->format->palette->colors[index];
	
	SDL_UnlockSurface(bitmap);

	return color->r;
	 */
}
